using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DoubleBuffer {
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class DoubleBufferForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DoubleBufferForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			this.SetStyle(ControlStyles.UserPaint, true);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItemDraw = new System.Windows.Forms.MenuItem();
			this.menuItemBuffer = new System.Windows.Forms.MenuItem();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItemDraw});
			// 
			// menuItemDraw
			// 
			this.menuItemDraw.Index = 0;
			this.menuItemDraw.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemBuffer});
			this.menuItemDraw.Text = "Draw";
			this.menuItemDraw.Popup += new System.EventHandler(this.menuItemDraw_Popup);
			// 
			// menuItemBuffer
			// 
			this.menuItemBuffer.Index = 0;
			this.menuItemBuffer.Text = "Double Buffer";
			this.menuItemBuffer.Click += new System.EventHandler(this.menuItemBuffer_Click);
			// 
			// DoubleBufferForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Menu = this.mainMenu1;
			this.Name = "DoubleBufferForm";
			this.Text = "DoubleBuffer";
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseDown);
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseUp);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.Form1_MouseMove);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new DoubleBufferForm());
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			Graphics g = e.Graphics;
			g.FillRectangle(Brushes.Green,100,100,200,100);
			g.FillRectangle(Brushes.Yellow,100,200,200,100);
			g.FillEllipse(Brushes.Red, rect);

		}

		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItemDraw;
		private System.Windows.Forms.MenuItem menuItemBuffer;

		Rectangle rect = new Rectangle(20,20,100,100);
		private void Form1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			Point pt = new Point(e.X, e.Y);
			if (ptDown != Point.Empty && rect.Contains(pt))  
			{
				Invalidate(rect);
				rect.Location = new Point(
					rect.Left + pt.X - ptDown.X,
					rect.Top + pt.Y - ptDown.Y);
				Rectangle rectInvalid = rect;
				Invalidate(rectInvalid);
				ptDown = pt;
			}
		}

		private void Form1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			ptDown = Point.Empty;
		}

		Point ptDown = Point.Empty;
		private void Form1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			ptDown = new Point(e.X, e.Y);
		}

		bool m_bBuffer = false;
		private void menuItemDraw_Popup(object sender, System.EventArgs e)
		{
			menuItemBuffer.Checked = m_bBuffer;
		}

		private void menuItemBuffer_Click(object sender, System.EventArgs e)
		{
			m_bBuffer = ! m_bBuffer;
			this.SetStyle(ControlStyles.DoubleBuffer, m_bBuffer);
			this.SetStyle(ControlStyles.AllPaintingInWmPaint, m_bBuffer);
			Invalidate();
		}

		protected override void OnPaintBackground(PaintEventArgs pevent)
		{
			base.OnPaintBackground (pevent);
		}


	}
}
